// WinDiceDlg.cpp : implementation file
//
/*
This program is copy righted both in whole and in part. 

Terms of Agreement:

If you use this code (in whole or in part) you agree to be bound by the following terms.

1) You may use this code in your own programs (and may compile it into a program and distribute it in compiled format freely and with no charge
   Provide that:
     a) the program this code (in whole or in part) is used within is not of a commerical nature.
     b) no fee is charged for the distribution nor access to this code, nor programs which contain any part of this code.

2) Permission is granted to redistribute this code (for example on a web site) provided that it remains intact and unmodified.. 

3) No warrenty, functionality, or suitability to any task is expressed, implied nor guarenteed by the author.

4) You agree to hold the author harmless, and assume all liability for any use of this code weither it is used in whole or in part.

5) This code is free. But, any program you use it in, must contain this copy right notice and must also be equally free.


Failure to abide by these terms and conditions is a violation of copyright laws.


I am releasing this source code only to help others. 
Please see to it that this spirit is relected in any works that contain any part of this code.

Bjorn A. Lovoll
bjorn@lovoll.net

If you found it useful, drop me a line. I would especially enjoy seeing any improvements you made to it.
*/

#include "stdafx.h"
#include "WinDice.h"
#include "WinDiceDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWinDiceDlg dialog

CWinDiceDlg::CWinDiceDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinDiceDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWinDiceDlg)
	m_strEDITDICE = _T("1");
	m_strEDITNUMBER = _T("1");
	m_strEDITPRAM = _T("roll 1  6-sided dice \r\r\n     +0/die      +0/roll ");
	m_strEDITRESULTS = _T("");
	m_nADDROLL = 0;
	m_nADDER = 0;
	m_nNUMBER = 0;
	m_nDICE = 3;
	m_nRadioADDDice=0;
	m_nRadioADDRoll=0;
	m_bEnableDice = FALSE;
	m_bEnableNum = FALSE;
	m_bEnableAddDice = FALSE;
	m_bEnableDieSize = TRUE;
	m_bEnableNumDice  = TRUE;
	m_bEnableAddRoll = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWinDiceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinDiceDlg)
	DDX_Text(pDX, IDC_EDITDICE, m_strEDITDICE);
	DDX_Text(pDX, IDC_EDITNUMBER, m_strEDITNUMBER);
	DDX_Text(pDX, IDC_EDITPRAM, m_strEDITPRAM);
	DDX_Text(pDX, IDC_EDITRESULTS, m_strEDITRESULTS);
	DDX_Radio(pDX, IDC_RADIO38, m_nADDROLL);
	DDX_Radio(pDX, IDC_RADIO14, m_nADDER);
	DDX_Radio(pDX, IDC_RADIO25, m_nNUMBER);
	DDX_Radio(pDX, IDC_RADIO1, m_nDICE);
	DDX_Radio(pDX, IDC_RadioADDRoll, m_nRadioADDRoll);
	DDX_Radio(pDX, IDC_RadioADDDice, m_nRadioADDDice);
	DDX_Check(pDX, IDC_EnableDice, m_bEnableDice);
	DDX_Check(pDX, IDC_EnableNum, m_bEnableNum);
	DDX_Check(pDX, IDC_EnableAddDice, m_bEnableAddDice);
	DDX_Check(pDX, IDC_EnableDieSize, m_bEnableDieSize);
	DDX_Check(pDX, IDC_EnableNumDice, m_bEnableNumDice);
	DDX_Check(pDX, IDC_EnableAddRoll, m_bEnableAddRoll);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWinDiceDlg, CDialog)
	//{{AFX_MSG_MAP(CWinDiceDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_ROLLEM, OnRollem)
	ON_BN_CLICKED(IDC_clear, OnClear)
	ON_BN_CLICKED(IDC_RADIO10, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO11, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO12, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO14, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO15, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO16, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO17, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO18, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO19, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO20, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO21, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO22, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO23, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO24, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO25, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO26, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO27, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO28, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO29, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO30, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO31, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO32, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO33, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO34, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO35, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO36, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO38, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO39, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO40, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO41, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO42, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO43, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO44, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO45, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO46, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO47, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO48, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO5, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO6, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO7, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO8, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO9, OnRadio1)
	ON_BN_CLICKED(IDC_RadioADDDice, OnRadio1)
	ON_BN_CLICKED(IDC_RadioADDDice2, OnRadio1)
	ON_BN_CLICKED(IDC_RadioADDRoll, OnRadio1)
	ON_BN_CLICKED(IDC_RadioADDRoll2, OnRadio1)
	ON_EN_CHANGE(IDC_EDITDICE, OnRadio1)
	ON_EN_CHANGE(IDC_EDITNUMBER, OnRadio1)
	ON_BN_CLICKED(IDC_EnableDice, OnBool1)
	ON_BN_CLICKED(IDC_EnableNum, OnBool1)
	ON_BN_CLICKED(IDC_EnableNumDice, OnBool1)
	ON_BN_CLICKED(IDC_EnableDieSize, OnBool1)
	ON_BN_CLICKED(IDC_EnableAddRoll, OnBool1)
	ON_BN_CLICKED(IDC_EnableAddDice, OnBool1)
		//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinDiceDlg message handlers

BOOL CWinDiceDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
		CWinDiceDlg::OnBool1();
		srand(getseed());

		//put the date on the screen
		UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWinDiceDlg::OnPaint() 
{	if (IsIconic())
	{	CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{	CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWinDiceDlg::OnQueryDragIcon()
{	return (HCURSOR) m_hIcon;
}

void CWinDiceDlg::OnRadio1()//This is the function call envoked by all of the radio buttons & edit windows.
{							//  This is what keeps the "your settings" window uptodate.
	CString strDICE;
	CString strNUMBER;
	CString strADDER;
	CString strADDERROLL;
	CString straddroll_p;
	CString stradddice_p;

	int diceholder=0, numberholder=0, adderholder=0,adderROLLholder=0;
	// get the current info from the program
	UpdateData(TRUE);

	GetDlgItem(IDC_RADIO1 +m_nDICE)->GetWindowText(strDICE);
	GetDlgItem(IDC_RADIO14 +m_nADDER)->GetWindowText(strADDER);
	GetDlgItem(IDC_RADIO25 +m_nNUMBER)->GetWindowText(strNUMBER);
	GetDlgItem(IDC_RADIO38 +m_nADDROLL)->GetWindowText(strADDERROLL);

	if(atoi(m_strEDITNUMBER))
		{	if(atoi(m_strEDITNUMBER)<251)
				{	numberholder= atoi(strNUMBER) * atoi(m_strEDITNUMBER);	}
			else
				{	m_strEDITNUMBER ="250";
					numberholder= atoi(strNUMBER) * atoi(m_strEDITNUMBER);
					MessageBox("Dice Number Multiplier must be between 1 and 250\nRemember you can use a larger base number to increase the range.","Oh Oh");
				}
		}
	else
		{	numberholder= atoi(strNUMBER); }


	if(atoi(m_strEDITDICE))
		{	if(atoi(m_strEDITDICE)<251)
				{	diceholder= atoi(strDICE) * atoi(m_strEDITDICE);	}
			else
				{	m_strEDITDICE ="250";
					diceholder= atoi(strDICE) * atoi(m_strEDITDICE);
					MessageBox("Dice Multiplier must be between 1 and 250\nRemember you can use a larger base die size to increase the range.","Oh Oh");
				}
		}
	else
		{	diceholder= atoi(strDICE);}
	
	adderholder =atoi(strADDER);
	adderROLLholder =atoi(strADDERROLL);

	
if(m_nRadioADDRoll)
	{	if(adderROLLholder)
			{straddroll_p = " ";}
		else
			{straddroll_p = "-";}
		adderROLLholder *=-1;
	}
else
	{	straddroll_p = "+";
	}

if(m_nRadioADDDice)
	{			if(adderholder)
					{stradddice_p = " ";}
				else
					{stradddice_p = "-";}
		adderholder*=-1;

	}
else
	{	stradddice_p = "+";
	}

	m_strEDITPRAM.Format(_T("roll %d  %d-sided dice \r\r\n     %s%d/die      %s%d/roll "),numberholder,diceholder,stradddice_p,adderholder,straddroll_p,adderROLLholder);
	
	//put the date on the screen
UpdateData(FALSE);
}



void CWinDiceDlg::OnRollem() //The function called by hitting the roll'em button.
{							//  This is where the random numbers are generated.
	CString strDICE;
	CString strNUMBER;
	CString  strHolder;
	CString strADDER;
	CString strADDERROLL;


	int diceholder=0, numberholder=0, adderholder=0, adderROLLholder=0, randholder;
	register int counter =0, counter2=0;
	long double total=0;
	// get the current info from the program
	UpdateData(TRUE);

	GetDlgItem(IDC_RADIO1 +m_nDICE)->GetWindowText(strDICE);
	GetDlgItem(IDC_RADIO14 +m_nADDER)->GetWindowText(strADDER);
	GetDlgItem(IDC_RADIO25 +m_nNUMBER)->GetWindowText(strNUMBER);
	GetDlgItem(IDC_RADIO38 +m_nADDROLL)->GetWindowText(strADDERROLL);

	if(atoi(m_strEDITDICE))
		{	diceholder= atoi(strDICE) * atoi(m_strEDITDICE);}
	else
		{	diceholder= atoi(strDICE);}
	if(atoi(m_strEDITNUMBER))
		{	numberholder= atoi(strNUMBER) * atoi(m_strEDITNUMBER);}
	else
		{	numberholder= atoi(strNUMBER); }
	
	m_strEDITRESULTS= "";  //Make sure the results are clear.  This helps with memory useage.
	

	adderholder=atoi(strADDER);
	adderROLLholder =atoi(strADDERROLL);
		
if(m_nRadioADDRoll)
	{	adderROLLholder *=-1;	}

if(m_nRadioADDDice)
	{	adderholder*=-1;}

	for (counter=0 ; counter  < numberholder ; counter++)
	{
		randholder = getnum(diceholder)+adderholder;
		total += (float)randholder;
		strHolder.Format(_T("%3d"),randholder);
		m_strEDITRESULTS += strHolder;
		counter2++;
		if( counter2> 5 )
			{	m_strEDITRESULTS +="\r\r\n"; // this is a softline feed for the edit box.
				counter2=0;
			}
		else
			{	if(counter < numberholder -1)
					{	m_strEDITRESULTS +=", ";
					}
			}
	}
	total +=adderROLLholder;
	strHolder.Format(_T("\r\r\n\r\r\nTotal = %10.0Lf\r\r\nAverage =%10.4Lf"),total,((total-adderROLLholder)/((float)numberholder)));
	m_strEDITRESULTS += strHolder;
	//put the date on the screen
	UpdateData(FALSE);
}


int CWinDiceDlg::getnum(int range)
{	
//  Number generator.  Gets a number from 1 to range.
	int d;
	d=(rand() % range)+1; 
	return(d);			  
	/*
	Even though is a fairly basic random number generator, it will generate a completely random number because the seed is
	always a unique number.  The seed is the entry point into the number table for the rand function.  With a random entry
	point it will produce a random number.  If you do not have a random seed, this is simply not possible.
	The only possible random seed is a time derivative.  Even with millisecond granularity, care must be taken to not 
	reinitilize the rand function with an identical seed.  I do this quite simply, but effectively.  Please review
	the getseed function for spedifics.

	There is one draw back to this quick and easy random number generator.
	rand is limted to MAX_RAND, or 32768 as the largest number it can generate on a single run.
	There are two methods you can work around this.  Both have compromises.
	mynumber=2*getnum(range) or mynumber=getnum(range)+getnum(range)
	Method #1 has the limitation of not as much granularity, but it is a 100% random number in the range.
	Method #2 has the granularity, but it bellcurves the distribution of the numbes to be more center weighted.
	*/
}

unsigned long CWinDiceDlg::getseed()
{
	unsigned long seed;
//getting a truely random seed based on time
 
//Initialize the randomizer
 
 /* sleeping for approx. 1 millisecond to ensure a 100% random seed .
    This is neccessary on very fast computers since they can loop in less then 1 millisecond.
    to wait for 1 second delete " / 999 "
    to wait for 5 seconds change, change (clock_t)1 to (clock_t)5 and delete " / 999 " */
	sleep( (clock_t)1 * ( CLOCKS_PER_SEC / 999 ) );
 
	SYSTEMTIME st	= {0}; 
	GetSystemTime(&st); 
 
 //using a unsigned int, since otherwise it converts the seed to a signed int.
 seed= ( time((time_t *) NULL) * CLOCKS_PER_SEC )+st.wMilliseconds;
 seed++; // incrementing the seed by 1 in case of very fast loops which reinitialize
/* 
The seed is incremented in two different ways to solve two different problems.
The wait is for fast computers looping.
The increment (++) is so the the randomizer can be reinitilized during the execution of the generator.
*/
return(seed);
}

void CWinDiceDlg::sleep(clock_t wait_length)
{  // do nothing loop based on time.  Used to control timing on very fast computers.
   clock_t stop_time;
   stop_time = wait_length + clock();
   while( stop_time > clock() )
      ;
}


void CWinDiceDlg::OnBool1() 
{	//is the enable button checked?
	UpdateData(TRUE);


	if (m_bEnableDice == TRUE)
	{	GetDlgItem(IDC_EDITDICE) -> ShowWindow(TRUE);
		GetDlgItem(IDC_STATIC_DIE) -> EnableWindow(TRUE);
	}
	else
	{	GetDlgItem(IDC_EDITDICE) -> ShowWindow(FALSE);
		GetDlgItem(IDC_STATIC_DIE) -> EnableWindow(FALSE);
	}


	if (m_bEnableNum == TRUE)
	{	GetDlgItem(IDC_EDITNUMBER) -> ShowWindow(TRUE);
		GetDlgItem(IDC_STATIC_NUM) -> EnableWindow(TRUE);
	}
	else
	{	GetDlgItem(IDC_EDITNUMBER) -> ShowWindow(FALSE);
		GetDlgItem(IDC_STATIC_NUM) -> EnableWindow(FALSE);
	}


	if (m_bEnableDieSize == TRUE)
	{	GetDlgItem(IDC_RADIO1) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO2) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO3) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO4) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO5) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO6) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO7) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO8) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO9) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO10) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO11) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO12) -> ShowWindow(TRUE);
		GetDlgItem(IDC_STATIC_DieSize) -> EnableWindow(TRUE);
		GetDlgItem(IDC_STATICDIE) -> EnableWindow(TRUE);
	}
	else
	{	GetDlgItem(IDC_RADIO1) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO2) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO3) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO4) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO5) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO6) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO7) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO8) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO9) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO10) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO11) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO12) -> ShowWindow(FALSE);
		GetDlgItem(IDC_STATIC_DieSize) -> EnableWindow(FALSE);
		GetDlgItem(IDC_STATICDIE) -> EnableWindow(FALSE);
	}


	if (m_bEnableNumDice == TRUE)
	{	GetDlgItem(IDC_RADIO25) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO26) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO27) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO28) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO29) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO30) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO31) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO32) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO33) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO34) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO35) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO36) -> ShowWindow(TRUE);
		GetDlgItem(IDC_STATIC_NUMBERDICE) -> EnableWindow(TRUE);
		GetDlgItem(IDC_STATICNUMBER) -> EnableWindow(TRUE);
	}
	else
	{	GetDlgItem(IDC_RADIO25) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO26) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO27) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO28) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO29) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO30) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO31) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO32) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO33) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO34) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO35) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO36) -> ShowWindow(FALSE);
		GetDlgItem(IDC_STATIC_NUMBERDICE) -> EnableWindow(FALSE);
		GetDlgItem(IDC_STATICNUMBER) -> EnableWindow(FALSE);
	}

	if (m_bEnableAddRoll == TRUE)
	{	GetDlgItem(IDC_RADIO38) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO39) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO40) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO41) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO42) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO43) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO44) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO45) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO46) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO47) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO48) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RadioADDRoll) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RadioADDRoll2) -> ShowWindow(TRUE);
		GetDlgItem(IDC_STATIC_ADDROLL) -> EnableWindow(TRUE);
		GetDlgItem(IDC_STATICADDROLL) -> EnableWindow(TRUE);
	}
	else
	{	GetDlgItem(IDC_RADIO38) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO39) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO40) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO41) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO42) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO43) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO44) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO45) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO46) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO47) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO48) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RadioADDRoll) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RadioADDRoll2) -> ShowWindow(FALSE);
		GetDlgItem(IDC_STATIC_ADDROLL) -> EnableWindow(FALSE);
		GetDlgItem(IDC_STATICADDROLL) -> EnableWindow(FALSE);
	}




	if (m_bEnableAddDice == TRUE)
	{	GetDlgItem(IDC_RADIO14) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO15) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO16) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO17) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO18) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO19) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO20) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO21) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO22) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO23) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RADIO24) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RadioADDDice) -> ShowWindow(TRUE);
		GetDlgItem(IDC_RadioADDDice2) -> ShowWindow(TRUE);
		GetDlgItem(IDC_STATIC_ADDDIE) -> EnableWindow(TRUE);
		GetDlgItem(IDC_STATICADDDIE) -> EnableWindow(TRUE);
	}
	else
	{	GetDlgItem(IDC_RADIO14) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO15) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO16) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO17) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO18) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO19) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO20) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO21) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO22) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO23) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RADIO24) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RadioADDDice) -> ShowWindow(FALSE);
		GetDlgItem(IDC_RadioADDDice2) -> ShowWindow(FALSE);
		GetDlgItem(IDC_STATIC_ADDDIE) -> EnableWindow(FALSE);
		GetDlgItem(IDC_STATICADDDIE) -> EnableWindow(FALSE);
	}

	UpdateData(FALSE);
}
void CWinDiceDlg::OnClear() 
{	//is the enable button checked?
	UpdateData(TRUE);
	m_strEDITDICE = _T("1");
	m_strEDITNUMBER = _T("1");
	m_strEDITPRAM = _T("roll 1  6-sided dice \r\r\n     +0/die      +0/roll ");
	m_strEDITRESULTS = _T("");
	m_nADDROLL = 0;
	m_nADDER = 0;
	m_nNUMBER = 0;
	m_nDICE = 3;
	m_nRadioADDDice=0;
	m_nRadioADDRoll=0;
	m_bEnableDice = FALSE;
	m_bEnableNum = FALSE;
	m_bEnableAddDice = FALSE;
	m_bEnableDieSize = TRUE;
	m_bEnableNumDice  = TRUE;
	m_bEnableAddRoll = FALSE;
	UpdateData(FALSE);
	OnBool1();
}